import React, { useState, useEffect } from 'react';
import { Form, Input, Button, Table, Select, Pagination, Space, Modal, message, Row, Col } from 'antd';
import { DownOutlined, PlusOutlined, ExclamationCircleOutlined } from '@ant-design/icons';
// import NormalPlayer from './testComponent/testComponent'
import '@common/common.less';
import apiObj from '@api/index';
import DataContext from './data-context';
import AddData from './AddData';
const { post, api, xPost, get } = apiObj;
const { Option } = Select;
function DataManager() {
  useEffect(() => {
    getDataAuthPage();
  }, []);
  const [userList, setUserList] = useState([]);
  const [id, setId] = useState("");
  const [modalType, setModalType] = useState("");
  const [msvisible, setMsvisible] = useState(false);
  const [type, setType] = useState("");
  const [addVisible, setaddVisible] = useState(false);
  const [dataDetail, setDataDetail] = useState(null);
  const [formData, setFormData] = useState(null);
  const [total, setTotal] = useState(0);
  const [tag, setTag] = useState([[]]);
  const [val, setVal] = useState([]);
  const [form] = Form.useForm();
  const tipText = {
    1: '确定要删除该数据权限？',
    2: '确定要禁用该数据权限?',
  };
  let params = {
    pages: 1,
    current: 1,
    size: 15
  }
  const showModal = (flag, id) => {
    setaddVisible(true)
    setType(flag)
    setId(id)
    if (flag == 1) {
      setFormData({
        status: '1'
      })
      setVal([])
    }
    if (flag == 3) {
      getDataAuthById(id)
    }
  }
  //表格数据
  function getDataAuthPage() {
    //const param = filterData;
    post(api.getDataAuthPage, params).then((res) => {
      if (res.data.code === 200) {
        const data = res.data.data;
        setUserList(data.records);
        setTotal(data.total)
      }
    })
  }
  //禁用启用
  const disableAuth = (id, status) => {
    let params = {
      id: id,
      status: status
    }
    xPost(api.disableAuth, params).then((res) => {
      if (res.data.code === 200) {
        getDataAuthPage();
        setMsvisible(false);
        message.success((status ? '启用' : '禁用') + "成功");
      } else {
        message.warning(res.data.msg || '操作失败');
      }
    })
  };
  //删除
  const deleteAuth = (id) => {
    let params = {
      id: id,
    }
    xPost(api.deleteAuth, params).then((res) => {
      if (res.data.code === 200) {
        getDataAuthPage();
        setMsvisible(false);
        message.success("删除成功");
      } else {
        message.warning(res.data.msg || '操作失败');
      }
    })
  };
  //查看
  function getDataAuthById(id) {
    xPost(api.getDataAuthById, { id: id }).then((res) => {
      if (res.data.code === 200) {
        const data = res.data.data;
        let roles = []
        let dataAuthDetails = []
        let selectedRowKeys = []
        let softwareMenuIds = []
        let arr = JSON.parse(JSON.stringify(data).replace(/softwares/g, 'softwareVOS').replace(/dataAuthDetail/g, 'dataAuthDetails'))
        arr.softwareVOS.map((it, i) => {
          roles[i] = []
          dataAuthDetails[i] = []
          selectedRowKeys[i] = []
          softwareMenuIds[i] = []
          tag[i] = []
          arr.softwareVOS[i].roles.forEach(item => {
            roles[i].push(item.id)
          })
          arr.softwareVOS[i].dataAuthDetails && arr.softwareVOS[i].dataAuthDetails.depts && arr.softwareVOS[i].dataAuthDetails.depts.forEach(item => {
            dataAuthDetails[i].push({
              dataType: 7,
              detailId: item.hospitalId,
              detailType: item.detailType
            })
            tag[i].push({
              id: item.id,
              name: item.name,
              type: item.detailType
            })
            softwareMenuIds[i].push(item.hospitalId + '-' + item.id + '-' + item.name)
          })
          arr.softwareVOS[i].dataAuthDetails && arr.softwareVOS[i].dataAuthDetails.doctors && arr.softwareVOS[i].dataAuthDetails.doctors.forEach(item => {
            dataAuthDetails[i].push({
              dataType: 7,
              detailId: item.id,
              detailType: item.detailType
            })
            tag[i].push({
              id: item.id,
              name: item.name,
              type: item.detailType
            })
            selectedRowKeys[i].push(item.id + '-' + item.name)
          })
          arr.softwareVOS[i].dataAuthDetails && arr.softwareVOS[i].dataAuthDetails.hospitals && arr.softwareVOS[i].dataAuthDetails.hospitals.forEach(item => {
            dataAuthDetails[i].push({
              dataType: 7,
              detailId: item.id,
              detailType: item.detailType
            })
            tag[i].push({
              id: item.id,
              name: item.name,
              type: item.detailType
            })
            softwareMenuIds[i].push(item.id + '-' + item.name)
          })
          arr.softwareVOS[i].roles = roles[i]
          arr.softwareVOS[i].dataAuthDetails = dataAuthDetails[i] && dataAuthDetails[i].length > 0 ? dataAuthDetails[i] : [{ dataType: it.dataType }]
          arr.softwareVOS[i].selectedRowKeys = selectedRowKeys[i]
          arr.softwareVOS[i].softwareMenuIds = softwareMenuIds[i]

          if (arr.softwareVOS[i].dataAuthDetails && arr.softwareVOS[i].dataAuthDetails.length > 0) {
            arr.softwareVOS[i].datatype = JSON.stringify(arr.softwareVOS[i].dataAuthDetails[0].dataType)
            val[i] = arr.softwareVOS[i].dataAuthDetails[0].dataType
          } else {
            arr.softwareVOS[i].datatype = JSON.stringify(arr.softwareVOS[i].dataType)
            val[i] = arr.softwareVOS[i].dataType
          }
        });
        setTag(tag)
        setVal(val)
        setFormData(arr)
      }
    })
  }
  //保存
  function addData(formData) {
    let url = api.addAuth;
    delete formData.roles
    const arr = formData.softwareVOS.filter((it) => {
      if (Object.keys(it).length && it.id ) {
        return it;
      }
    });
    formData.softwareVOS = arr;
    let param = {
      addDataAuthVO: formData,
    }
    if (type == 3) {
      url = api.updateAuth
      param = {
        updateDataAuthVO: {
          ...formData,
          id: id
        },
      }
    }
    post(url, param).then((res) => {
      if (res.data.code === 200) {
        getDataAuthPage();
        setaddVisible(false)
        message.success("添加成功");
      } else {
        message.warning(res.data.msg || '操作失败');
      }
    }).catch(() => {
      message.error("接口出错");
    });
  }
  const onFinish = (value) => {
    params = {
      ...value,
      ...params
    }
    getDataAuthPage();
  };
  const onReset = () => {
    form.resetFields();
    getDataAuthPage();
  };
  const messageBox = (type, id) => {
    setMsvisible(true)
    setId(id)
    setModalType(type)
  };
  const columns = [
    { title: '数据权限名称', dataIndex: 'name', key: 'index' },
    { title: '所属角色', dataIndex: 'roleName', key: 'index' },
    {
      title: '状态', dataIndex: 'status', key: 'status', render: (text, record) => (
        <Space size="middle">
          {record.status == 1 ?
            <span className="Enable">启用</span>
            :
            <span className="Disable">禁用</span>
          }
        </Space>
      )
    },
    {
      title: '操作', dataIndex: 'key', render: (text, record) => (
        <Space size="middle">
          <a onClick={e => showModal(3, record.id)}>修改</a>
          {record.status === '1' ? (<a className="disable" onClick={() => messageBox(2, record.id)}>禁用</a>) : (<a onClick={() => disableAuth(record.id, 1)}>启用</a>)}
          <a className="delete" onClick={() => messageBox(1, record.id)} >删除</a>
        </Space>
      )
    }
  ]
  function showAddData() {
    setaddVisible(true)
  }

  //提示框确认事件
  function handleOk() {
    if (modalType == 1) {
      deleteAuth(id, 0)
    } else if (modalType == 2) {
      disableAuth(id, 0)
    }
  }
  //提示框取消
  function handleCancel() {
    setMsvisible(false);
  }
  function goBack() {
    setaddVisible(false)
    setFormData(null)
    getDataAuthPage()
  }
  function onSizeChange(current, pageSize) {
    params.current = current
    params.size = pageSize
    getDataAuthPage()
  }
  function changePage(page, pageSize) {
    params.current = page
    params.size = pageSize
    getDataAuthPage()
  }
  if (addVisible && formData) {
    return (
      <DataContext.Provider value={{ save: addData, formData: formData, type, val, tag }}>
        <AddData back={goBack} />
      </DataContext.Provider>
    )
  }
  return (
    <div className="wrapper">
      <div className="filter-box">
        <Form
          form={form}
          name="normal_login"

          onFinish={onFinish}
          initialValues={{ status: '' }}
        >
          <Row gutter={24}>
            <Col span={5} key={0}>
              <Form.Item label="数据权限名称" name="username">
                <Input placeholder="用户名" />
              </Form.Item>
            </Col>
            <Col span={5} key={1}>
              <Form.Item label="所属角色" name="name">
                <Input placeholder="姓名" />
              </Form.Item>
            </Col>
            <Col span={5} key={2}>
              <Form.Item label="当前状态" name="status">
                <Select
                  placeholder="Select a person"
                >
                  <Option value="">全部</Option>
                  <Option value="1">启用</Option>
                  <Option value="0" >禁用</Option>
                </Select>
              </Form.Item>
            </Col>
            <Col span={6} key={3}>
              <Form.Item>
                <Button type="primary" htmlType="submit">
                  查询
                </Button>
                <Button onClick={onReset}>
                  重置
                </Button>
              </Form.Item>
            </Col>
          </Row>
        </Form>
      </div>
      <div className="table">
        <div className="table-header">
          <h2 className="table-title">数据权限</h2>
          <Button type="primary" icon={<PlusOutlined />} onClick={e => showModal(1)}>新增数据权限</Button>
        </div>

        <Table
          columns={columns}
          dataSource={userList}
          rowKey={record => record.id + record.roleName}
          pagination={{
            pageNo: 1,
            pageSize: params.size,
            pageSizeOptions: ['15', '30', '60', '120'],
            showTotal: (total, range) => `第${range[0]}-${range[1]} 条/共 ${total} 条数据`,
            onShowSizeChange: (current, pageSize) => onSizeChange(current, pageSize), // 改变每页数量时更新显示
            onChange: (page, pageSize) => changePage(page, pageSize),//点击页码事件
            total: total
          }} />
      </div>
      <Modal
        title="提示"
        okText='确定'
        cancelText='取消'
        width={400}
        visible={msvisible}
        onOk={handleOk}
        onCancel={handleCancel}
      >
        <p>{tipText[modalType]}</p>
      </Modal>
    </div >
  )
}

export default DataManager;